// ===========================================================================
// AnotherVision.h
// definition of application
//
//                                                       by kanegon 2006
// ===========================================================================

#pragma once

#undef IDC_STATIC
#include "resource.h"
#include "common.h"


// ---------------------------------------------------------------------------

#define APP_MUTEX                 _T("singleinstance.mutex.anothervision.kanegon")
#define APP_REG_KEY               _T("Software\\kanegon\\AnotherVision")
#define ANOTHERVISION_NT          _T("anothervision_nt.exe")
#define LOCALE_RESOURCE_FILENAME  _T("avres.dll")
#define LOCALE_RESOURCE_ROOT_DIR  _T("resource")
#define APP_SYSTEM_FILTER_DIR     _T("filter\\system")
#define APP_PRIVATE_FILTER_DIR    _T("filter\\private")
#define APP_FILTER_FILE           _T("*.xml")
#define APP_WINDOW_TITLE          _T("AnotherVision")
#define APP_NOTIFYICON_TIP        _T("AnotherVision")
#define APP_NOTIFYICON_ID         100
#define APP_VIEW_HOTKEY_ID        100
#define MAX_HOTKEY                 10
#define APP_QUICK_HOTKEY_ID_BEGIN 120
#define APP_QUICK_HOTKEY_ID_END   (APP_QUICK_HOTKEY_ID_BEGIN + MAX_HOTKEY - 1) // 129
#define TEXT_BUFFER_SIZE          512
#define MAX_FILTER_WND             20
#define MAX_COLOR_EXTEND           18  // really, limit to 12 by setting dialog
#define MAX_ZOOM                   20
#define MIN_ZOOM                   -3


// ---------------------------------------------------------------------------

#define RGB_DISPLAY_TYPE_RGB_DEC          0
#define RGB_DISPLAY_TYPE_RGB_HEX          1
#define RGB_DISPLAY_TYPE_RGB_HSV          2
#define RGB_DISPLAY_TYPE_RGB_HSV_CUSTOM   3
#define RGB_DISPLAY_TYPE_RGB_HSV_SIMPLE   4

#define RGB_DISPLAY_TYPE_MAX              5

#define IMAGE_QUALITY_LEVEL_LOW           0
#define IMAGE_QUALITY_LEVEL_NORMAL        1
#define IMAGE_QUALITY_LEVEL_HIGH          2
#define IMAGE_QUALITY_LEVEL_MAX           3

// ---------------------------------------------------------------------------

#define MSG_ERROR_EXEC_UNICODEAPP    _T("execute unicode application failed.")
#define MSG_ERROR_RESOURCE_MISSING   _T("error occured. [resource missing, ID=%d]")

#define MSG_ERROR_UNEXPECTED         _T("%s(%d): error occured. [unexpected]")
#define MSG_ERROR_NO_MEMORY          _T("%s(%d): error occured. [no memory]")
#define MSG_ERROR_INTERFACE_ERROR    _T("%s(%d): error occured. [interface error]")
#define MSG_ERROR_SYSTEM_ERROR       _T("%s(%d): error occured. [system error, code=%d]")

#define APPERROR_UNEXPECTED()  ExMessageBoxText(MB_OK | MB_ICONSTOP, MSG_ERROR_UNEXPECTED, __TFILE__, __LINE__)
#define APPERROR_NO_MEMORY()   ExMessageBoxText(MB_OK | MB_ICONSTOP, MSG_ERROR_NO_MEMORY, __TFILE__, __LINE__)
#define APPERROR_SYSTEM()      ExMessageBoxText(MB_OK | MB_ICONSTOP, MSG_ERROR_SYSTEM_ERROR, __TFILE__, __LINE__, GetLastError())
#define APPERROR_INTERFACE()   ExMessageBoxText(MB_OK | MB_ICONSTOP, MSG_ERROR_INTERFACE_ERROR, __TFILE__, __LINE__)


// ---------------------------------------------------------------------------

#define WM_EX_NOTIFYICON             (WM_APP + 0x0001)
#define WM_EX_ESCAPE                 (WM_APP + 0x0002)
#define WM_EX_FILTER_CHANGED         (WM_APP + 0x0003)
#define WM_EX_FILTERVIEW_DELAY       (WM_APP + 0x0004)
#define WM_EX_QUICKVIEW_DELAY        (WM_APP + 0x0005)
#define WM_EX_ZOOM                   (WM_APP + 0x0006)
#define WM_EX_CENTER_MARK            (WM_APP + 0x0007)
#define WM_EX_TOPMOST                (WM_APP + 0x0008)
#define WM_EX_FIX_MOUSE_POSITION     (WM_APP + 0x0009)
#define WM_EX_SHOW_STATUSBAR         (WM_APP + 0x000A)
#define WM_EX_STATUSBAR_PARTS_CHANGE (WM_APP + 0x000B)
#define WM_EX_WINDOW_TOP             (WM_APP + 0x000C)
#define WM_EX_LEFTTOP_ORIGIN         (WM_APP + 0x000D)


// ---------------------------------------------------------------------------

#define MENUPOS_WINDOW_CONTEXT_FILTER                  0
#define MENUPOS_WINDOW_CONTEXT_ZOOM                    1
#define MENUPOS_WINDOW_CONTEXT_CENTER_MARK             2
#define MENUPOS_WINDOW_CONTEXT_FIX_MOUSE_POSITION      3
#define MENUPOS_WINDOW_CONTEXT_SEPARATOR1              4
#define MENUPOS_WINDOW_CONTEXT_VIEW                    5
#define MENUPOS_WINDOW_CONTEXT_SEPARATOR2              6
#define MENUPOS_WINDOW_CONTEXT_NEW_WINDOW              7
#define MENUPOS_WINDOW_CONTEXT_SEPARATOR3              8
#define MENUPOS_WINDOW_CONTEXT_CLOSE                   9

#define MENUPOS_WINDOW_CONTEXT_VIEW_TOPMOST            0
#define MENUPOS_WINDOW_CONTEXT_VIEW_SHOW_STATUSBAR     1


#define MENUPOS_TASKTRAY_CONTEXT_DESKTOP               0
#define MENUPOS_TASKTRAY_CONTEXT_WINDOW                1
#define MENUPOS_TASKTRAY_CONTEXT_SEPARATOR1            2
#define MENUPOS_TASKTRAY_CONTEXT_QUICK                 3
#define MENUPOS_TASKTRAY_CONTEXT_SEPARATOR2            4
#define MENUPOS_TASKTRAY_CONTEXT_LOAD_WINDOW_SETTING   5
#define MENUPOS_TASKTRAY_CONTEXT_SAVE_WINDOW_SETTING   6
#define MENUPOS_TASKTRAY_CONTEXT_CLOSE_ALL_WINDOW      7
#define MENUPOS_TASKTRAY_CONTEXT_SEPARATOR3            8
#define MENUPOS_TASKTRAY_CONTEXT_FILTER_OPTION         9
#define MENUPOS_TASKTRAY_CONTEXT_OPTION               10
#define MENUPOS_TASKTRAY_CONTEXT_SEPARATOR4           11
#define MENUPOS_TASKTRAY_CONTEXT_ABOUT                12
#define MENUPOS_TASKTRAY_CONTEXT_SEPARATOR5           13
#define MENUPOS_TASKTRAY_CONTEXT_APP_EXIT             14


// ---------------------------------------------------------------------------

void SetFatalError(BOOL bEnable = TRUE);
BOOL IsFatalError();
BOOL IsAppShuttingDown();
void SetAppShuttingDown(BOOL bEnable);
HMODULE GetResourceHandle();
HMODULE GetSystemResourceHandle();

