// ===========================================================================
// AnotherVision filter load test
//
//                                                       by kanegon 2006
// ===========================================================================

#include "stdafx.h"
#include <exception>
#include <stdio.h>
#include "AnotherVision.h"
#include "xstr.h"
#include "AppException.h"


// ---------------------------------------------------------------------------
// constructor
// ---------------------------------------------------------------------------
AppException::AppException() : m_com_error(E_FAIL)
{
	m_dwType = APPERR_TYPE_UNEXPECTED;
	ZeroMemory(m_szMessage, sizeof(m_szMessage));
}

// ---------------------------------------------------------------------------
// constructor
// ---------------------------------------------------------------------------
AppException::AppException(DWORD dwType, LPCTSTR pszMessage, LPCTSTR pszFileName, int nLineNumber) : m_com_error(E_FAIL)
{
	m_dwType = dwType;
	if (pszFileName != NULL) {
		_sntprintf(m_szMessage, APPEXCEPTION_MSG_MAX,
				_T("error: %s(%d): %d: %s"), pszFileName, nLineNumber, dwType, pszMessage);
	}
	else {
		_sntprintf(m_szMessage, APPEXCEPTION_MSG_MAX,
				_T("error: %d: %s"), dwType, pszMessage);
	}
}

// ---------------------------------------------------------------------------
// constructor
// ---------------------------------------------------------------------------
AppException::AppException(const _com_error& e) : m_com_error(e)
{
	m_dwType = APPERR_TYPE_COMERROR;
	_sntprintf(m_szMessage, APPEXCEPTION_MSG_MAX,
			_T("com_error: 0x%08x: %s"), e.Error(), (LPCTSTR)e.ErrorMessage());
}

// ---------------------------------------------------------------------------
// constructor
// ---------------------------------------------------------------------------
AppException::AppException(const exception& e) : m_com_error(E_FAIL)
{
	m_dwType = APPERR_TYPE_CPPERROR;
	_bstr_t strMsg = e.what();
	_sntprintf(m_szMessage, APPEXCEPTION_MSG_MAX,
			_T("exception: %s"), (LPCTSTR)strMsg);
}

// ---------------------------------------------------------------------------
// destructor
// ---------------------------------------------------------------------------
AppException::~AppException()
{
}

// ---------------------------------------------------------------------------
// get type
// ---------------------------------------------------------------------------
DWORD AppException::GetType()
{
	return m_dwType;
}

// ---------------------------------------------------------------------------
// get message
// ---------------------------------------------------------------------------
LPCTSTR AppException::GetMessage()
{
	return m_szMessage;
}
