// ===========================================================================
// AppException
//
//                                                       by kanegon 2006
// ===========================================================================

#pragma once

#include "common.h"


// ---------------------------------------------------------------------------

#define APPEXCEPTION_MSG_MAX     4096

#define APPERR_TYPE_SUCCESS         0
#define APPERR_TYPE_UNEXPECTED      1
#define APPERR_TYPE_INTERNAL        2
#define APPERR_TYPE_NOMEMORY        3
#define APPERR_TYPE_SYSTEM          4
#define APPERR_TYPE_INTERFACE       5
#define APPERR_TYPE_APPLICATION     6
#define APPERR_TYPE_COMERROR       10
#define APPERR_TYPE_CPPERROR       11


// ---------------------------------------------------------------------------
// application exception class
// ---------------------------------------------------------------------------
class AppException {
protected:
	DWORD m_dwType;
	TCHAR m_szMessage[APPEXCEPTION_MSG_MAX + 1];
	_com_error m_com_error;
	exception m_exception;

	void SetMessage(LPCTSTR pszMessage);

public:
	AppException();
	AppException(DWORD dwType, LPCTSTR pszMessage, LPCTSTR pszFileName = NULL, int nLineNumber = 0);
	AppException(const _com_error& e);
	AppException(const exception& e);
	virtual ~AppException();
	virtual LPCTSTR GetMessage();
	virtual DWORD GetType();
};

// ---------------------------------------------------------------------------

inline void appThrow(LPCTSTR pszMessage, LPCTSTR pszFileName = NULL, int nLineNumber = 0)
{
	throw AppException(APPERR_TYPE_APPLICATION, pszMessage, pszFileName, nLineNumber);
}

inline void appThrow(const _com_error& e)
{
	throw AppException(e);
}

inline void appThrow(const exception& e)
{
	throw AppException(e);
}

#define APPTHROW(msg) appThrow(msg, __TFILE__, __LINE__)
#define APPTHROW_COM_ERROR(e) appThrow(e)
#define APPTHROW_EXCEPTION(e) appThrow(e)

