// ===========================================================================
// FilterOptionDlg.h
// option dialog
//
//                                                       by kanegon 2006
// ===========================================================================

#pragma once

#include "filter.h"
#include "AnotherVision.h"
#include "HotKeyManager.h"


// ---------------------------------------------------------------------------
// option dialog class
// ---------------------------------------------------------------------------
class CFilterOptionDlg : public CDialogImpl<CFilterOptionDlg>
{
private:
	static HWND ms_hwndDlg;
	static volatile BOOL ms_bShowDlg;
	COLOR_FILTER_PTR_ARRAY m_EnableFilterPtrList;
	CFilter* m_pPrevSelectFilter;
	CHotKeyManager m_HotKeyManager;

	CListBox m_FilterListbox;
	CListBox m_DisabledFilterListbox;
	CButton m_FilterUpBtn;
	CButton m_FilterDownBtn;
	CButton m_FilterEnableBtn;
	CButton m_FilterDisableBtn;
	CHotKeyCtrl m_QuickHotkey;
	CEdit m_IDEdit;
	CEdit m_NameEdit;

	BOOL IsValidHotkeySetting();
	BOOL LoadProfile();
	BOOL SaveProfile();
	void ControlVariableMapping();
	void InitControls();
	void EnableButtons(BOOL bUpdateList = FALSE);
	void UpItem();
	void DownItem();
	void EnableFilter(COLOR_FILTER_PTR_ARRAY& EnableFilterList);
	void DisableFilter(int nIndex);
	void UpdateHotKeyData();
	void SetHotKeyManager(CHotKeyManager& manager) {
		m_HotKeyManager = manager;
	}
	CHotKeyManager& GetHotKeyManager() {
		return m_HotKeyManager;
	}
	void GetDisabledFilterList(COLOR_FILTER_PTR_ARRAY& DisabledFilterPtrList);

public:
	static BOOL IsShowed();
	static BOOL Show(CHotKeyManager& HotKeyManager);

public:
	enum { IDD = IDD_FILTER_OPTION_DLG };

	BEGIN_MSG_MAP(CFilterOptionDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_HANDLER(IDC_FOPTION_FILTER_UP_BUTTON, BN_CLICKED, OnUpItem)
		COMMAND_HANDLER(IDC_FOPTION_FILTER_DOWN_BUTTON, BN_CLICKED, OnDownItem)
		COMMAND_HANDLER(IDC_FOPTION_FILTER_E_LIST, LBN_SELCHANGE, OnControlStatusChanged)
		COMMAND_HANDLER(IDC_FOPTION_FILTER_D_LIST, LBN_SELCHANGE, OnControlStatusChanged)
		COMMAND_HANDLER(IDC_FOPTION_FILTER_DISABLE_BUTTON, BN_CLICKED, OnFilterDisableItem)
		COMMAND_HANDLER(IDC_FOPTION_FILTER_ENABLE_BUTTON, BN_CLICKED, OnFilterEnableItem)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnOK(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnControlStatusChanged(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnUpItem(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnDownItem(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnFilterDisableItem(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnFilterEnableItem(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	virtual INT_PTR DoModal(HWND hWndParent = ::GetActiveWindow(), LPARAM dwInitParam = NULL) {
		ATLASSERT(m_hWnd == NULL);
		_AtlWinModule.AddCreateWndData(&m_thunk.cd, (CDialogImplBaseT<CWindow>*)this);
#ifdef _DEBUG
		m_bModal = true;
#endif //_DEBUG
		return ::DialogBoxParam(GetResourceHandle(), MAKEINTRESOURCE(IDD),
				hWndParent, CFilterOptionDlg::StartDialogProc, dwInitParam);
	}
};
