// ===========================================================================
// FilterStatus.h
// color filter status
//
//                                                       by kanegon 2006
// ===========================================================================

#pragma once

#include "Filter.h"


// ---------------------------------------------------------------------------
// color filter status class
// ---------------------------------------------------------------------------
class CFilterStatus {
private:
	BOOL m_bQuickMode;

	// status of current filter
	int m_nSelectedEnableFilterIndex;
	CFilter* m_pCurrentFilter;
	int m_nRepeat;

	// status of current filter element in reference filter
	int m_nCurrentRepeatCount;
	int m_nCurrentRefFilterIndex;
	int m_nCurrentTimeout;
	CFilter* m_pCurrentRawFilter;
	DWORD m_dwTime;

public:
	CFilterStatus();
	CFilterStatus(const CFilterStatus& status);
	virtual ~CFilterStatus();
	CFilterStatus& operator=(const CFilterStatus& status);

	void SetQuickMode(BOOL bEnable = TRUE);

	void ResetSelectedEnableFilterIndex();
	void SetSelectedEnableFilterIndex(int nIndex);
	int GetSelectedEnableFilterIndex();
	CFilter* GetSelectedEnableFilter();

	void ResetFilterItem();
	BOOL HasNextFilterItem();
	BOOL IsNextFilterItemReady();
	CFilter* NextFilterItem();
	CFilter* LastFilterItem();
};
