// ===========================================================================
// HotKeyManager.cpp
// hotkey manager
//
//                                                       by kanegon 2006
// ===========================================================================

#include "stdafx.h"
#include "AnotherVision.h"
#include "Profile.h"
#include "Filter.h"
#include "MainFrm.h"
#include "HotKeyManager.h"


// ---------------------------------------------------------------------------
// 
// ---------------------------------------------------------------------------
void CHotKeyManager::LoadProfile()
{
	m_dwViewKey = GetAppProfile()->GetViewHotKey();
	m_QuickKeyList.clear();
	QUICKKEY_ITEM_ARRAY& QuickKeyList = GetAppProfile()->GetQuickKeys();
	int i;
	for (i = 0; i < (int)QuickKeyList.size(); i++) {
		CQuickKeyItem& key = QuickKeyList[i];
		CFilter* pFilter = GetAppFilterManager()->GetFilter((LPCTSTR)key.GetFilterID());
		if (pFilter == NULL) {
			continue;
		}
		if (GetAppFilterManager()->GetEnableFilterIndex(pFilter) == -1) {
			continue;
		}
		m_QuickKeyList.push_back(CQuickKey(pFilter, key.GetHotKey()));
	}
}

// ---------------------------------------------------------------------------
// 
// ---------------------------------------------------------------------------
void CHotKeyManager::SaveProfile()
{
	GetAppProfile()->SetViewHotKey(m_dwViewKey);
	QUICKKEY_ITEM_ARRAY QuickKeyList;
	int i;
	for (i = 0; i < (int)m_QuickKeyList.size(); i++) {
		CQuickKey& key = m_QuickKeyList[i];
		CFilter* pFilter = key.GetFilter();
		if (pFilter == NULL) {
			continue;
		}
		QuickKeyList.push_back(CQuickKeyItem((LPCTSTR)pFilter->GetID(), key.GetHotKey()));
	}
	GetAppProfile()->SetQuickKeys(QuickKeyList);
}

// ---------------------------------------------------------------------------
// 
// ---------------------------------------------------------------------------
BOOL CHotKeyManager::RegisterViewHotKey()
{
	if (m_dwViewKey != 0) {
		UINT nKeyCode = LOWORD(m_dwViewKey);
		UINT nModifiers = HIWORD(m_dwViewKey);
		m_bViewKeyRegistered = RegisterHotKey(GetAppMainFrame()->m_hWnd, APP_VIEW_HOTKEY_ID, nModifiers, nKeyCode);
		if (! m_bViewKeyRegistered) {
			m_dwViewKey = 0;
			ExMessageBox(MB_OK, IDS_ERROR_REGISTER_HOTKEY, GetLastError());
		}
	}
	return TRUE;
}

// ---------------------------------------------------------------------------
// 
// ---------------------------------------------------------------------------
void CHotKeyManager::UnregisterViewHotKey()
{
	if (m_bViewKeyRegistered) {
		UnregisterHotKey(GetAppMainFrame()->m_hWnd, APP_VIEW_HOTKEY_ID);
	}
	m_bViewKeyRegistered = FALSE;
}

// ---------------------------------------------------------------------------
// 
// ---------------------------------------------------------------------------
BOOL CHotKeyManager::RegisterQuickHotKey()
{
typedef std::vector<int> INT_ARRAY;
	int i;
	for (i = 0; i < (int)m_QuickKeyList.size(); i++) {
		CQuickKey& key = m_QuickKeyList[i];
		DWORD dwHotKey = key.GetHotKey();
		if (dwHotKey != 0) {
			UINT nKeyCode = LOWORD(dwHotKey);
			UINT nModifiers = HIWORD(dwHotKey);
			BOOL bRegistered = RegisterHotKey(GetAppMainFrame()->m_hWnd, APP_QUICK_HOTKEY_ID_BEGIN + i, nModifiers, nKeyCode);
			key.SetRegistered(bRegistered);
			if (! bRegistered) {
				ExMessageBox(MB_OK, IDS_ERROR_REGISTER_HOTKEY, GetLastError());
			}
		}
	}
	return TRUE;
}

// ---------------------------------------------------------------------------
// 
// ---------------------------------------------------------------------------
void CHotKeyManager::UnregisterQuickHotKey()
{
	int i;
	for (i = 0; i < (int)m_QuickKeyList.size(); i++) {
		CQuickKey& key = m_QuickKeyList[i];
		if (key.IsRegistered()) {
			UnregisterHotKey(GetAppMainFrame()->m_hWnd, APP_QUICK_HOTKEY_ID_BEGIN + i);
		}
		key.SetRegistered(FALSE);
	}
}
