// ===========================================================================
// MainFrm.cpp
// main window for manage tasktray icon.
// this window is not visible.
//
//                                                       by kanegon 2006
// ===========================================================================

#include "stdafx.h"
#include "AnotherVision.h"
#include "Profile.h"
#include "Aboutdlg.h"
#include "FilterOptionDlg.h"
#include "OptionDlg.h"
#include "PreviewWnd.h"
#include "FilterWnd.h"
#include "MainFrm.h"


// ---------------------------------------------------------------------------

#define MAINWND_TIMER_ID      100
#define MAINWND_TIMER_ELAPSE  100


// ---------------------------------------------------------------------------

static
CMainFrame* s_pWndMainFrame = NULL;


// ---------------------------------------------------------------------------
// get main window
// ---------------------------------------------------------------------------
CMainFrame* GetAppMainFrame()
{
	return s_pWndMainFrame;
}

// ---------------------------------------------------------------------------
// register tasktray icon
// ---------------------------------------------------------------------------
BOOL CMainFrame::RegisterTasktrayIcon()
{
	NOTIFYICONDATA NotifyIconData;
	ZeroMemory(&NotifyIconData, sizeof(NotifyIconData));
	NotifyIconData.cbSize  = sizeof(NotifyIconData);
	NotifyIconData.hWnd    = m_hWnd;
	NotifyIconData.uID     = APP_NOTIFYICON_ID;
	NotifyIconData.uFlags  = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	NotifyIconData.uCallbackMessage = WM_EX_NOTIFYICON;
	NotifyIconData.hIcon   = LoadIcon(GetSystemResourceHandle(), MAKEINTRESOURCE(IDI_ANOTHERVISION_SMALL));
	lstrcpy(NotifyIconData.szTip, APP_NOTIFYICON_TIP);
	return Shell_NotifyIcon(NIM_ADD, &NotifyIconData);
}

// ---------------------------------------------------------------------------
// unregister tasktray icon
// ---------------------------------------------------------------------------
void CMainFrame::UnregisterTasktrayIcon()
{
	NOTIFYICONDATA NotifyIconData;
	ZeroMemory(&NotifyIconData, sizeof(NotifyIconData));
	NotifyIconData.cbSize  = sizeof(NotifyIconData);
	NotifyIconData.hWnd    = m_hWnd;
	NotifyIconData.uID     = APP_NOTIFYICON_ID;
	Shell_NotifyIcon(NIM_DELETE, &NotifyIconData);
}

// ---------------------------------------------------------------------------
// 
// ---------------------------------------------------------------------------
void CMainFrame::ShowPopupMenu()
{
	POINT pos;
	SetForegroundWindow(m_hWnd);
	GetCursorPos(&pos);
	CMenuHandle menu = m_menuTaskTrayPopup.GetSubMenu(0);

	CMenuHandle menuFilter = menu.GetSubMenu(MENUPOS_TASKTRAY_CONTEXT_QUICK);
	int nItems = menuFilter.GetMenuItemCount();
	int i;
	for (i = 0; i < nItems; i++) {
		menuFilter.DeleteMenu(0, MF_BYPOSITION);
	}
	int nEnableFilterNum = GetAppFilterManager()->GetEnableFilterCount();
	for (i = 0; i < nEnableFilterNum; i++) {
		CFilter* pFilter = GetAppFilterManager()->GetEnableFilter(i);
		xstr_t strName = pFilter->GetName();
		MENUITEMINFO MenuItemInfo;
		ZeroMemory(&MenuItemInfo, sizeof(MenuItemInfo));
		MenuItemInfo.cbSize = sizeof(MenuItemInfo);
		MenuItemInfo.fMask = MIIM_FTYPE | MIIM_ID | MIIM_STATE | MIIM_STRING;
		MenuItemInfo.fType = MFT_STRING;
		MenuItemInfo.fState = 0;
		MenuItemInfo.wID = ID_WINDOW_FILTER_BEGIN + i;
		MenuItemInfo.dwTypeData = (LPTSTR)(LPCTSTR)strName;
		MenuItemInfo.cch = 0;
		menuFilter.InsertMenuItem(i, TRUE, &MenuItemInfo);
	}

	BOOL bEnableView = TRUE;
	BOOL bEnableWindow = TRUE;
	BOOL bEnableOption = TRUE;
	BOOL bEnableFilterOption = TRUE;

	if (COptionDlg::IsShowed()) {
		bEnableOption = FALSE;
		bEnableFilterOption = FALSE;
		bEnableView = FALSE;
	}
	if (CFilterOptionDlg::IsShowed()) {
		bEnableOption = FALSE;
		bEnableFilterOption = FALSE;
		bEnableView = FALSE;
		bEnableWindow = FALSE;
	}
	if (CPreviewWnd::IsShowed()) {
		bEnableView = FALSE;
		bEnableOption = FALSE;
		bEnableFilterOption = FALSE;
	}
	if (CFilterWnd::GetWndListCount() > 0) {
		bEnableFilterOption = FALSE;
	}

	MENUITEMINFO MenuItemInfo;
	ZeroMemory(&MenuItemInfo, sizeof(MenuItemInfo));
	MenuItemInfo.cbSize = sizeof(MenuItemInfo);
	MenuItemInfo.fMask = MIIM_STATE;
	MenuItemInfo.fState = bEnableView ? MFS_ENABLED : MFS_DISABLED;
	menu.SetMenuItemInfo(MENUPOS_TASKTRAY_CONTEXT_DESKTOP, TRUE, &MenuItemInfo);

	ZeroMemory(&MenuItemInfo, sizeof(MenuItemInfo));
	MenuItemInfo.cbSize = sizeof(MenuItemInfo);
	MenuItemInfo.fMask = MIIM_STATE;
	MenuItemInfo.fState = bEnableWindow ? MFS_ENABLED : MFS_DISABLED;
	menu.SetMenuItemInfo(MENUPOS_TASKTRAY_CONTEXT_WINDOW, TRUE, &MenuItemInfo);

	ZeroMemory(&MenuItemInfo, sizeof(MenuItemInfo));
	MenuItemInfo.cbSize = sizeof(MenuItemInfo);
	MenuItemInfo.fMask = MIIM_STATE;
	MenuItemInfo.fState = bEnableView ? MFS_ENABLED : MFS_DISABLED;
	menu.SetMenuItemInfo(MENUPOS_TASKTRAY_CONTEXT_QUICK, TRUE, &MenuItemInfo);

	ZeroMemory(&MenuItemInfo, sizeof(MenuItemInfo));
	MenuItemInfo.cbSize = sizeof(MenuItemInfo);
	MenuItemInfo.fMask = MIIM_STATE;
	MenuItemInfo.fState = bEnableFilterOption ? MFS_ENABLED : MFS_DISABLED;
	menu.SetMenuItemInfo(MENUPOS_TASKTRAY_CONTEXT_FILTER_OPTION, TRUE, &MenuItemInfo);

	ZeroMemory(&MenuItemInfo, sizeof(MenuItemInfo));
	MenuItemInfo.cbSize = sizeof(MenuItemInfo);
	MenuItemInfo.fMask = MIIM_STATE;
	MenuItemInfo.fState = bEnableOption ? MFS_ENABLED : MFS_DISABLED;
	menu.SetMenuItemInfo(MENUPOS_TASKTRAY_CONTEXT_OPTION, TRUE, &MenuItemInfo);

	menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_TOPALIGN, pos.x, pos.y, m_hWnd);
}

// ---------------------------------------------------------------------------
// OnCreate
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	s_pWndMainFrame = this;
	m_HotKeyManager.LoadProfile();

	RegisterTasktrayIcon();
	m_uTaskbarCreatedMessage = RegisterWindowMessage(_T("TaskbarCreated"));
	m_menuTaskTrayPopup = LoadMenu(GetResourceHandle(), MAKEINTRESOURCE(IDM_TASKTRAY_CONTEXT_MENU));

	m_HotKeyManager.RegisterViewHotKey();
	m_HotKeyManager.RegisterQuickHotKey();

	m_nTimerID = SetTimer(MAINWND_TIMER_ID, 100, NULL);

	return 0;
}

// ---------------------------------------------------------------------------
// OnClose
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnClose(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	DestroyWindow();
	return 0;
}

// ---------------------------------------------------------------------------
// OnDestroy
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	if (m_nTimerID != 0) {
		KillTimer(MAINWND_TIMER_ID);
		m_nTimerID = 0;
	}
	m_HotKeyManager.UnregisterViewHotKey();
	m_HotKeyManager.UnregisterQuickHotKey();
	UnregisterTasktrayIcon();

	m_HotKeyManager.SaveProfile();
	PostQuitMessage(0);
	s_pWndMainFrame = NULL;
	return 0;
}

// ---------------------------------------------------------------------------
// OnEndSession
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnEndSession(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	GetAppProfile()->WriteProfile();
	SetAppShuttingDown(TRUE);
	return 0;
}

// ---------------------------------------------------------------------------
// OnHotkey
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnHotkey(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	UINT nID = (UINT)wParam;
	if (nID == APP_VIEW_HOTKEY_ID) {
		CPreviewWnd::Activate();
	}
	else if (nID >= APP_QUICK_HOTKEY_ID_BEGIN && nID <= APP_QUICK_HOTKEY_ID_END) {
		int nIndex = nID - APP_QUICK_HOTKEY_ID_BEGIN;
		CFilter* pFilter = m_HotKeyManager.GetFilter(nIndex);
		int nFilterIndex = GetAppFilterManager()->GetEnableFilterIndex(pFilter);
		if (nFilterIndex != -1) {
			CPreviewWnd::Activate(TRUE, nFilterIndex);
		}
	}
	return 0;
}

// ---------------------------------------------------------------------------
// OnTimer
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	return 0;
}

// ---------------------------------------------------------------------------
// OnNotifyIcon
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnNotifyIcon(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
{
	switch (lParam) {
	case WM_LBUTTONUP:
	case WM_RBUTTONUP: {
		SetForegroundWindow(m_hWnd);
		ShowPopupMenu();
		break;
	}
	default:
		break;
	}

	return 0;
}

// ---------------------------------------------------------------------------
// OnFilterViewDelay
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnFilterViewDelay(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
{
	if (lParam > 0) {
		Sleep(lParam);
		PostMessage(WM_EX_FILTERVIEW_DELAY, 0, 0);
	}
	else {
		CPreviewWnd::Activate(FALSE);
	}
	return 0;
}

// ---------------------------------------------------------------------------
// OnQuickView
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnQuickViewDelay(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	if (lParam > 0) {
		Sleep(lParam);
		PostMessage(WM_EX_QUICKVIEW_DELAY, wParam, 0);
	}
	else {
		int nFilterIndex = wParam;
		CFilter* pFilter = GetAppFilterManager()->GetEnableFilter(nFilterIndex);
		if (pFilter != NULL) {
			CPreviewWnd::Activate(TRUE, nFilterIndex);
		}
	}
	return 0;
}

// ---------------------------------------------------------------------------
// OnTaskbarCreated
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnTaskbarCreated(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	RegisterTasktrayIcon();
	return 0;
}

// ---------------------------------------------------------------------------
// OnQuickSelect
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnQuickSelect(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
{
	int nFilterIndex = wID - ID_WINDOW_FILTER_BEGIN;
	CFilter* pFilter = GetAppFilterManager()->GetEnableFilter(nFilterIndex);
	if (pFilter != NULL) {
		PostMessage(WM_EX_QUICKVIEW_DELAY, nFilterIndex, 50);
	}
	return 0;
}

// ---------------------------------------------------------------------------
// OnAppExit
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnAppExit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	SetAppShuttingDown(TRUE);
	PostMessage(WM_CLOSE);
	return 0;
}

// ---------------------------------------------------------------------------
// OnAbout
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CAboutDlg::Show();
	return 0;
}

// ---------------------------------------------------------------------------
// OnOption
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnOption(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CAppProfile tmpProfile(*GetAppProfile());
	m_HotKeyManager.UnregisterViewHotKey();
	CHotKeyManager tmpHotKeyManager = m_HotKeyManager;
	BOOL bResult = COptionDlg::Show(tmpHotKeyManager);
	if (bResult) {
		m_HotKeyManager = tmpHotKeyManager;
		CFilterWnd::PostMessageToAllWindow(WM_EX_STATUSBAR_PARTS_CHANGE);
	}
	if (! IsAppShuttingDown()) {
		m_HotKeyManager.RegisterViewHotKey();
	}
	return 0;
}

// ---------------------------------------------------------------------------
// OnFilterOption
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnFilterOption(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CAppProfile tmpProfile(*GetAppProfile());
	m_HotKeyManager.UnregisterQuickHotKey();
	CHotKeyManager tmpHotKeyManager = m_HotKeyManager;
	BOOL bResult = CFilterOptionDlg::Show(tmpHotKeyManager);
	if (bResult) {
		m_HotKeyManager = tmpHotKeyManager;
		GetAppFilterManager()->ActivateFilters();
	}
	if (! IsAppShuttingDown()) {
		m_HotKeyManager.RegisterQuickHotKey();
	}
	return 0;
}

// ---------------------------------------------------------------------------
// OnFilterMode
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnFilterMode(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	PostMessage(WM_EX_FILTERVIEW_DELAY, 0, 50);
	return 0;
}

// ---------------------------------------------------------------------------
// OnFilterWindow
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnFilterWindow(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CreateFilterWnd();
	return 0;
}

// ---------------------------------------------------------------------------
// OnSaveFilterWindowSetting
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnSaveFilterWindowSetting(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CFilterWnd::SaveAllWindowSetting();
	return 0;
}

// ---------------------------------------------------------------------------
// OnLoadFilterWindowSetting
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnLoadFilterWindowSetting(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CFilterWnd::LoadAllWindowSetting();
	return 0;
}

// ---------------------------------------------------------------------------
// OnCloseAllWindow
// ---------------------------------------------------------------------------
LRESULT CMainFrame::OnCloseAllWindow(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CFilterWnd::PostMessageToAllWindow(WM_CLOSE);
	return 0;
}

