// ===========================================================================
// MainFrm.h
// main window, but this window is not visible
//
//                                                       by kanegon 2006
// ===========================================================================

#pragma once

#include "PreviewWnd.h"
#include "HotKeyManager.h"

// ---------------------------------------------------------------------------

class CMainFrame;
CMainFrame* GetAppMainFrame();


// ---------------------------------------------------------------------------
// main window class
// this window is not visible
// ---------------------------------------------------------------------------
class CMainFrame : public CFrameWindowImpl<CMainFrame>
{
private:
	CPreviewWnd m_PreviewWnd;
	CMenu m_menuTaskTrayPopup;
	UINT m_uTaskbarCreatedMessage;
	UINT_PTR m_nTimerID;
	CHotKeyManager m_HotKeyManager;

	BOOL RegisterTasktrayIcon();
	void UnregisterTasktrayIcon();
	void ShowPopupMenu();

public:
	DECLARE_FRAME_WND_CLASS(NULL, IDR_MAINFRAME)

	BEGIN_MSG_MAP(CMainFrame)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_ENDSESSION, OnEndSession)
		MESSAGE_HANDLER(WM_HOTKEY, OnHotkey)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
		MESSAGE_HANDLER(WM_EX_NOTIFYICON, OnNotifyIcon)
		MESSAGE_HANDLER(WM_EX_FILTERVIEW_DELAY, OnFilterViewDelay)
		MESSAGE_HANDLER(WM_EX_QUICKVIEW_DELAY, OnQuickViewDelay)
		MESSAGE_HANDLER(m_uTaskbarCreatedMessage, OnTaskbarCreated)
		COMMAND_RANGE_HANDLER_EX(ID_WINDOW_FILTER_BEGIN, ID_WINDOW_FILTER_END, OnQuickSelect)
		COMMAND_ID_HANDLER(ID_APPLICATION_EXIT, OnAppExit)
		COMMAND_ID_HANDLER(ID_ABOUT, OnAbout)
		COMMAND_ID_HANDLER(ID_OPTION, OnOption)
		COMMAND_ID_HANDLER(ID_FILTER_OPTION, OnFilterOption)
		COMMAND_ID_HANDLER(ID_FILTER_VIEW, OnFilterMode)
		COMMAND_ID_HANDLER(ID_FILTER_WINDOW, OnFilterWindow)
		COMMAND_ID_HANDLER(ID_SAVE_FILTER_WINDOW_SETTING, OnSaveFilterWindowSetting)
		COMMAND_ID_HANDLER(ID_LOAD_FILTER_WINDOW_SETTING, OnLoadFilterWindowSetting)
		COMMAND_ID_HANDLER(ID_CLOSE_ALL_WINDOW, OnCloseAllWindow)
		CHAIN_MSG_MAP(CFrameWindowImpl<CMainFrame>)
	END_MSG_MAP()

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnClose(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnEndSession(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnHotkey(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnTimer(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnNotifyIcon(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnFilterViewDelay(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnQuickViewDelay(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnTaskbarCreated(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnQuickSelect(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/);
	LRESULT OnAppExit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnOption(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnFilterOption(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnFilterMode(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnFilterWindow(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnSaveFilterWindowSetting(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnLoadFilterWindowSetting(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCloseAllWindow(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
};

