// ===========================================================================
// OperateWnd.h
// filter operate panel
//
//                                                       by kanegon 2006
// ===========================================================================

#pragma once


// ---------------------------------------------------------------------------
// filter operate panel class
// ---------------------------------------------------------------------------
class COperateWnd : public CWindowImpl<COperateWnd>,
		public CMessageFilter
{
private:
	CListBox m_FilterListbox;
	CButton m_CloseBtn;
	int m_nCurrentFilterIndex;
	int m_nFontHeight;
	int m_nListBoxItemHeight;
	BOOL m_bInitialized;

	BOOL InitControls();
	void InitFilters();
	void SaveWindowPosition();

public:
	BOOL CreateHelper(HWND hwnd);
	void GetInitialWindowRect(LPRECT pRect);
	void RecalcLayout();
	void AdjustInitialPanelHeight();
	void SetInitialized(BOOL bEnable) {
		m_bInitialized = bEnable;;
	}
	BOOL IsInitialized() {
		return m_bInitialized;
	}
	BOOL PreTranslateMessage2(MSG* pMsg);

public:
	static ATL::CWndClassInfo& GetWndClassInfo() {
		static ATL::CWndClassInfo wc = {
				{sizeof(WNDCLASSEX), 0, StartWindowProc, 0, 0,
				NULL, LoadIcon(_Module.get_m_hInstResource(), MAKEINTRESOURCE(IDR_MAINFRAME)), NULL,
				(HBRUSH)NULL, NULL, NULL, NULL},
				NULL, NULL, IDC_ARROW, TRUE, 0, _T("") 
			};
		return wc;
	}

	BEGIN_MSG_MAP(COperateWnd)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_KEYDOWN, OnKeyDown)
		MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
		MESSAGE_HANDLER(WM_IME_SETCONTEXT, OnImeSetContext)
		MESSAGE_HANDLER(WM_GETMINMAXINFO, OnGetMinMaxInfo)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		MESSAGE_HANDLER(WM_EX_ESCAPE, OnEscape)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_HANDLER(IDC_PANEL_CLOSE_BUTTON, BN_CLICKED, OnCloseBtn)
		COMMAND_HANDLER(IDC_PANEL_FILTER_LIST, LBN_SELCHANGE, OnFilterSelChange)
	END_MSG_MAP()

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnClose(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnKeyDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSetFocus(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnImeSetContext(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnGetMinMaxInfo(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnEscape(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnOK(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCloseBtn(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnFilterSelChange(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	virtual BOOL PreTranslateMessage(MSG* pMsg) {
		BOOL bResult = ::IsDialogMessage(m_hWnd, pMsg);
		if (pMsg->hwnd == m_hWnd || ::GetParent(pMsg->hwnd) == m_hWnd) {
			bResult |= PreTranslateMessage2(pMsg);
		}
		return bResult;
	}
};
