// ===========================================================================
// OptionDlg.h
// option dialog
//
//                                                       by kanegon 2006
// ===========================================================================

#pragma once

#include "filter.h"
#include "AnotherVision.h"
#include "HotKeyManager.h"


// ---------------------------------------------------------------------------
// option dialog class
// ---------------------------------------------------------------------------
class COptionDlg : public CDialogImpl<COptionDlg>
{
private:
	static xstr_t ms_strRGBType[RGB_DISPLAY_TYPE_MAX];
	static xstr_t ms_strImageQualityLevel[IMAGE_QUALITY_LEVEL_MAX];
	static HWND ms_hwndDlg;
	static volatile BOOL ms_bShowDlg;

public:
	static BOOL InitConstant();
	static BOOL IsShowed();
	static BOOL Show(CHotKeyManager& HotKeyManager);

private:
	CHotKeyManager m_HotKeyManager;

	CHotKeyCtrl m_ViewHotkey;
	CButton m_ViewAdjustInitialPanelHeightCheck;
	CComboBox m_QuickWaitingTimeCombo;
	CComboBox m_WindowUpdateIntervalCombo;
	CComboBox m_WindowRGBTypeCombo;
	CButton m_WindowUnvisibleCheck;
	CButton m_WindowSimpleStatusbarInfoCheck;
	CButton m_WindowShowOriginalColorInfoCheck;
	CComboBox m_ImageQualityCombo;
	CButton m_NoSplashCheck;

	BOOL LoadProfile();
	BOOL SaveProfile();
	void ControlVariableMapping();
	void InitControls();
	void EnableButtons(BOOL bUpdateList = FALSE);
	void UpItem();
	void DownItem();
	void EnableFilter(COLOR_FILTER_PTR_ARRAY& EnableFilterList);
	void DisableFilter(int nIndex);
	void UpdateHotKeyData();
	void SetHotKeyManager(CHotKeyManager& manager) {
		m_HotKeyManager = manager;
	}
	CHotKeyManager& GetHotKeyManager() {
		return m_HotKeyManager;
	}

public:
	enum { IDD = IDD_OPTION_DLG };

	BEGIN_MSG_MAP(COptionDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnOK(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnControlStatusChanged(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	virtual INT_PTR DoModal(HWND hWndParent = ::GetActiveWindow(), LPARAM dwInitParam = NULL) {
		ATLASSERT(m_hWnd == NULL);
		_AtlWinModule.AddCreateWndData(&m_thunk.cd, (CDialogImplBaseT<CWindow>*)this);
#ifdef _DEBUG
		m_bModal = true;
#endif //_DEBUG
		return ::DialogBoxParam(GetResourceHandle(), MAKEINTRESOURCE(IDD),
				hWndParent, COptionDlg::StartDialogProc, dwInitParam);
	}
};
