// ===========================================================================
// PreviewWnd.h
// preview window
//
//                                                       by kanegon 2006
// ===========================================================================

#pragma once

#include "OperateWnd.h"
#include "Filter.h"
#include "FilterStatus.h"
#include "CaptureImage.h"


// ---------------------------------------------------------------------------
// preview window class
// ---------------------------------------------------------------------------
class CPreviewWnd : public CWindowImpl<CPreviewWnd>
{
private:
	CCaptureImage m_CaptureImage;
	BOOL m_bShowed;
	int m_nDesktopWidth;
	int m_nDesktopHeight;
	int m_nInitialFilterIndex;
	int m_nSelectFilterIndex;
	COperateWnd m_OperateWnd;
	UINT_PTR m_nTimerID;
	BOOL m_bClosing;
	CFilterStatus m_FilterStatus;
	BOOL m_bQuickMode;
	DWORD m_dwQuickFilterEndTime;
	BOOL m_bQuickFilterEnd;

	BOOL CaptureScreen();
	void ApplyFilter(CFilter* pFilter);
	void ChangeFilter(CFilter* pFilter);
	void QuickFilterEnd();

public:
	static BOOL IsShowed();
	static void Activate(BOOL bQuick = FALSE, int nFilterIndex = 0);
	static BOOL CreateHelper(BOOL bQuick, int nFilterIndex = 0);

public:
	CPreviewWnd();

	void ActivateOperateWnd();

public:
	static ATL::CWndClassInfo& GetWndClassInfo() {
		static ATL::CWndClassInfo wc = {
				{sizeof(WNDCLASSEX), CS_DBLCLKS, StartWindowProc, 0, 0,
				NULL, LoadIcon(_Module.get_m_hInstResource(), MAKEINTRESOURCE(IDR_MAINFRAME)), NULL,
				(HBRUSH)NULL, NULL, NULL, NULL},
				NULL, NULL, IDC_ARROW, TRUE, 0, _T("") 
			};
		return wc;
	}

	BEGIN_MSG_MAP(CPreviewWnd)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_CLOSE, OnClose)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_KEYDOWN, OnKeyDown)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBkGnd)
		MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
		MESSAGE_HANDLER(WM_MOUSEACTIVATE, OnMouseActivate)
		MESSAGE_HANDLER(WM_IME_SETCONTEXT, OnIMESetContext)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
		MESSAGE_HANDLER(WM_LBUTTONDBLCLK, OnLButtonDblClk)
		MESSAGE_HANDLER(WM_EX_FILTER_CHANGED, OnFilterChange)
	END_MSG_MAP()

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnClose(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnKeyDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnEraseBkGnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnSetFocus(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnMouseActivate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnIMESetContext(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnTimer(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnLButtonDblClk(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnFilterChange(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);

	virtual void OnFinalMessage(HWND /*hWnd*/);
};
