// ===========================================================================
// common.h
// common utility
//
//                                                       by kanegon 2006
// ===========================================================================

#pragma once

#include <stdio.h>
#include <vector>
#include "xstr.h"


// ---------------------------------------------------------------------------

#ifdef UNICODE
#define __TFILE__   __WFILE__
#else
#define __TFILE__   __FILE__
#endif

#define WIDEN2(x) L ## x
#define WIDEN(x) WIDEN2(x)
#define __WFILE__ WIDEN(__FILE__)


// ---------------------------------------------------------------------------

#define IsFlag(value, flag)  (((value) & (flag)) != 0)
#define IsFlagEx(value, flag, mask)  (((value) & (mask)) == (flag))


// ---------------------------------------------------------------------------

typedef std::vector<int> INT_ARRAY;
typedef std::vector<xstr_t> XSTR_ARRAY;


// ---------------------------------------------------------------------------

LPCTSTR GetModuleDir();
BOOL IsFile(LPCTSTR pszPath);
BOOL IsDirectory(LPCTSTR pszPath);
BOOL ExReadFile(LPCTSTR pszPath, LPBYTE* ppBuffer, DWORD* pdwBufferSize);
BOOL ExWriteFile(LPCTSTR pszPath, LPBYTE pBuffer, DWORD dwBufferSize);

BOOL IsWinNT();
BOOL IsWin2K();
BOOL IsWinXP();
BOOL IsWinVista();

BOOL ReadRegText(LPCTSTR pszRegKey, LPCTSTR pszRegName, LPTSTR pszValue, DWORD dwValueSize, LPCTSTR pszDefault);
BOOL ReadRegInt(LPCTSTR pszRegKey, LPCTSTR pszRegName, DWORD* pdwValue, DWORD dwDefaultValue);
VOID WriteRegText(LPCTSTR pszRegKey, LPCTSTR pszRegName, LPCTSTR pszValue);
VOID WriteRegInt(LPCTSTR pszRegKey, LPCTSTR pszRegName, DWORD dwValue);

void ValidateHResult(HRESULT hr);
void TrimText(LPTSTR pszText);
BOOL ExSetForegroundWindow(HWND hwnd);
BOOL ExecCmd(LPCTSTR pszAppPath);
DWORD GetProductVersionMS(LPCTSTR pszPath);
BOOL ExLoadString(UINT nID, LPTSTR pBuffer, int nBufferSize);
void CopyClipboard(LPCTSTR pszText);

int ExMessageBoxText(UINT nType, LPCTSTR pszFmt, ...);
int ExMessageBox(UINT nType, UINT nID, ...);

